var currCut = null;
var currCopy = null;
var lockMan = null;
var gVars = Components.classes['@senior_design.jhu/globalvars;1'].getService().wrappedJSObject;

function populateList() {
	try {

		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "wait";

		var xmlDoc = propFind(null);

		if(xmlDoc === null)
			return;

		var responses = xmlDoc.getElementsByTagNameNS("DAV:", "response");

		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
		list.clearSelection();

		for(var i = list.getRowCount() - 1; i >= 0; i--)
			list.removeItemAt(i);

		var text, type, created, modified, size, lock, file, prop, row, cols;
		var prefixlen = responses.item(0).getElementsByTagNameNS("DAV:", "href").item(0).firstChild.nodeValue.length;

		for(var x = 1; x < responses.length; x++) {
			file = responses.item(x).getElementsByTagNameNS("DAV:", "href");
			prop = responses.item(x).getElementsByTagNameNS("DAV:", "prop");

                        if(file.length <= 0 || prop.length <= 0)
                            continue;

                        file = file.item(0);
                        prop = prop.item(0);

			row = gBrowser.selectedBrowser.contentDocument.createElement("listitem");
			cols = [ gBrowser.selectedBrowser.contentDocument.createElement("listcell"), gBrowser.selectedBrowser.contentDocument.createElement("listcell"),
			         gBrowser.selectedBrowser.contentDocument.createElement("listcell"), gBrowser.selectedBrowser.contentDocument.createElement("listcell"),
			         gBrowser.selectedBrowser.contentDocument.createElement("listcell"), gBrowser.selectedBrowser.contentDocument.createElement("listcell"),
			         gBrowser.selectedBrowser.contentDocument.createElement("listcell")];

			text = file.firstChild.nodeValue.substring(prefixlen);
			type = prop.getElementsByTagNameNS("DAV:", "getcontenttype");
			created = prop.getElementsByTagNameNS("DAV:", "creationdate");
			modified = prop.getElementsByTagNameNS("DAV:", "getlastmodified");
			size = prop.getElementsByTagNameNS("DAV:", "getcontentlength");
			lock = prop.getElementsByTagNameNS("DAV:", "activelock");

			if (type.length === 0)
				type = "";
			else
				type = type.item(0).firstChild.nodeValue;
			if (created.length === 0)
				created = "";
			else
				created = created.item(0).firstChild.nodeValue;
			if (modified.length === 0)
				modified = "";
			else
				modified = modified.item(0).firstChild.nodeValue;
			if (size.length === 0)
				size = "";
			else
				size = size.item(0).firstChild.nodeValue;
			if(lock.length === 0)
				lock = "";
			else
				lock = "x";

			if(text[text.length - 1] === '/') {
				text = text.substring(0, text.length - 1);
				cols[0].setAttribute("label", "dir");
			}
			cols[0].setAttribute("hidden", "true");
			cols[1].setAttribute("label", decodeURL(text));
			cols[2].setAttribute("label", type);
			cols[3].setAttribute("label", size);
			cols[4].setAttribute("label", created);
			cols[5].setAttribute("label", modified);
			cols[6].setAttribute("label", lock);

			row.appendChild(cols[0]);
			row.appendChild(cols[1]);
			row.appendChild(cols[2]);
			row.appendChild(cols[3]);
			row.appendChild(cols[4]);
			row.appendChild(cols[5]);
			row.appendChild(cols[6]);

			list.appendChild(row);
		}

		if(gVars.curr_dir !== gVars.start_dir) {
			gBrowser.selectedBrowser.contentDocument.getElementById("back_button").wrappedJSObject.disabled = false;
			document.title = gVars.base_url + gVars.curr_dir;
		}
		else {
			gBrowser.selectedBrowser.contentDocument.getElementById("back_button").wrappedJSObject.disabled = true;
			gBrowser.selectedBrowser.contentDocument.title = gVars.base_url;
		}

		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "";
	}
	catch(err) {
		alert("populateList: " + err);
		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "";
	}
}

function onCut() {
	var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
	if(list.selectedItem === null)
		return;

	currCut = gVars.curr_dir + list.selectedItem.childNodes[1].getAttribute("label");

	if(list.selectedItem.childNodes[0].getAttribute("label") === "dir" )
		currCut += "/";

	if(currCopy !== null)
		currCopy = null;
}

function onCopy() {
	var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
	if(list.selectedItem === null)
		return;

	currCopy = gVars.curr_dir + list.selectedItem.childNodes[1].getAttribute("label");

	if(list.selectedItem.childNodes[0].getAttribute("label") === "dir" )
		currCopy += "/";

	if(currCut !== null)
		currCut = null;
}

function onPaste() {
	try {
		if(lockMan == null) {
			lockMan = new LockManager();
			lockMan.loadLocks();
		}

		var type = "COPY";
		var src = currCopy;

		if(currCut !== null) {
			type = "MOVE";
			src = currCut;
		}

		var fname = src;
		var index = fname.length - 1;

		if(fname[index] == "/")
			index --;

		fname = fname.substring(fname.lastIndexOf("/", index));

		//check for overwriting and give option to cancel
		if(gVars.curr_dir === src.substring(0,src.length-fname.length + 1) && (type === "COPY")) {
			var ext = "";
			ext = fname.substring(fname.lastIndexOf("."));
			if (ext !== "")
				fname = fname.substring(0,fname.length-ext.length) + "(copy)" + ext;
		}

		var req = new XMLHttpRequest();
		req.open(type, gVars.base_url + src, false);
		req.setRequestHeader("Destination", gVars.base_url + gVars.curr_dir + fname);

		var tokenSrc = null;
		if(type === "MOVE")
			tokenSrc = lockMan.getToken(src);

		var tokenDst = lockMan.getToken(gVars.curr_dir);

		var header = "";
		if(tokenSrc !== null)
			header = "<" + gVars.base_url + src + "> (" + tokenSrc + ")";

		if(tokenDst !== null) {
			if(header !== "")
				header += "\n";

			header +=  "<" + gVars.base_url + gVars.curr_dir + "> (" + tokenDst + ")";
		}

		if(header !== "")
			req.setRequestHeader("If", header);

		req.send("");
		if(req.status === 201 || req.status === 204) {
			populateList();
		}
		else if(req.status === 423) {
			alert("File is locked");
		}
		else if(req.status === 412) {
			lockMan.removeLock(src);
			onPaste();
		}
		else {
			alert("Invalid Response from Server.\nServer Response: " + req.status + " " + req.statusText);
			return null;
		}

		if(type === "MOVE") {
			currCut = null;
		}

	}
	catch(e) {
		alert("onPaste: " + e);
	}
}

function lockSelection() {
	try {

		if(lockMan == null) {
			lockMan = new LockManager();
			lockMan.loadLocks();
		}

		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
		if(list.selectedItem === null)
			return;

		var selection = gVars.curr_dir + list.selectedItem.childNodes[1].getAttribute("label");

		if(list.selectedItem.childNodes[0].getAttribute("label") === "dir")
			selection += "/";

		var req = new XMLHttpRequest();
		req.open("LOCK", gVars.base_url + selection, false);
		req.setRequestHeader("Content-Type", 'text/xml; charset="utf-8"');
		req.setRequestHeader("Timeout", "Second-600");

		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "wait";
		req.send("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<D:lockinfo xmlns:D=\"DAV:\">\n<D:lockscope>\n<D:exclusive/>\n</D:lockscope>\n<D:locktype>\n<D:write/>\n</D:locktype>\n<D:owner>\n<D:href>MozWebFolder</D:href>\n</D:owner>\n</D:lockinfo>");
		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "";

		if(req.status === 200) {
			var token = req.getResponseHeader("Lock-Token");
			lockMan.addLock(selection, token);
			populateList();
			lockMan.saveLocks();
		}
		else if(req.status === 423) {
			alert("File is already locked.");
		}
		else {
			alert("Invalid response from server.\nServer Response: " + req.status + " " + req.statusText);
			return null;
		}
	}
	catch(err) {
		alert("lockSelection: " + err);
	}
}

function unlockSelection() {
	try {

		if(lockMan == null) {
			lockMan = new LockManager();
			lockMan.loadLocks();
		}

		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
		if(list.selectedItem === null)
			return;

		var selection = gVars.curr_dir + list.selectedItem.childNodes[1].getAttribute("label");
		var tok = lockMan.getToken(selection);

		if(tok === null) {
			alert("Unlock failed: Either the file is not locked or you do not own this lock");
			return;
		}

		if(list.selectedItem.childNodes[0].getAttribute("label") === "dir")
			selection += "/";

		var req = new XMLHttpRequest();
		req.open("UNLOCK", gVars.base_url + selection, false);
		req.setRequestHeader("Lock-Token", tok);

		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "wait";
		req.send("");
		gBrowser.selectedBrowser.contentDocument.documentElement.style.cursor = "";

		if(req.status === 204) {
			lockMan.removeLock(selection);
		}
		else if(req.status === 423) {
			alert("File is already locked.");
		}
		else {
			alert("Unlock failed: Either the file is not locked or the file is locked at a higher level\n" + req.status + " " + req.statusText);
			lockMan.removeLock(selection);
		}
		populateList();
	}
	catch(err) {
		alert("lockSelection: " + err);
	}
}


function onMakeDir () {
	var dir = prompt("Enter a name for you're new directory","");
	if(dir[dir.length-1] !== '/')
		dir += "/";
	makeDir(dir);
}

function makeDir(directory) {
	var address = gVars.base_url + gVars.curr_dir + directory;

	if(lockMan == null) {
		lockMan = new LockManager();
		lockMan.loadLocks();
	}

	var req = new XMLHttpRequest();
	req.open("MKCOL", address, false);
	var tok = lockMan.getToken(gVars.curr_dir);

	if(tok !== null)
		req.setRequestHeader("If", "<" + gVars.base_url + gVars.curr_dir + "> (" + tok + ")");

	req.send("");
	if(req.status === 201) {
		populateList();
	}
	else if(req.status === 412) {
		lockMan.removeLock(gVars.base_url + gVars.curr_dir);
		makeDir(directory);
	}
	else
		alert("Failed to make directory " + directory + ".\n Server Response: " + req.status + " " + req.statusText);

}


function DeleteFile() {

	try {

		if(lockMan == null) {
			lockMan = new LockManager();
			lockMan.loadLocks();
		}
		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;

		if(list.selectedItem === null)
			return;

		var selection = list.selectedItem;
		var url = gVars.curr_dir + selection.childNodes[1].getAttribute("label");

		var tok = lockMan.getToken(url);

		if(list.selectedItem.childNodes[0].getAttribute("label") === "dir")
			url += "/";

		var req = new XMLHttpRequest();
		req.open("Delete", gVars.base_url + url, false);

		if(tok !== null)
			req.setRequestHeader("If", "<" + gVars.base_url + url + "> (" + tok + ")");

		req.send("");
		if(req.status === 204) {
			populateList();
		}
		else if(req.status === 423) {
			alert("File is locked");
		}
		else if(req.status === 412) {
			lockMan.removeLock(url);
			DeleteFile();
		}
		else {
			alert("Invalid Response from Server.\nServer Response: " + req.status + " " + req.statusText);
			return null;
		}

	}
	catch(err) {
		alert("DeleteFile: " + err);
	}

}

function downloadFile() {
	try {
		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;

		if(list.selectedItem === null)
			return;

		var selection = list.selectedItem;
		var url = gVars.base_url + gVars.curr_dir + selection.childNodes[1].getAttribute("label");

		//file is not a directory
		var type = selection.childNodes[0].getAttribute("label");
		if(type !== "dir") {
			var fd = new FileDownloader(url, type);
			fd.start();
		}
		else
			alert("Directories cannot be downloaded.  Please select a file.");
	}
	catch(err) {
		alert("downloadFile: " + err);
	}

}

function changeServer() {

	try {
		var address = prompt("Please enter address","");
		if(address === null || address === '')
			return;

		var H = address.substring(0,7);
		var S = address.substring(0,8);

		if(H !== "http://" && S !== "https://")
			address = "http://" + address;

		if(address.charAt(address.length - 1) !== '/')
			address += "/";

		var dav_level = checkForDav(address);

		if(dav_level < 1) {
			alert(address + " is not a WebDAV Server");
			return;
		}
		else
			gVars.davLevel = dav_level;

		var ind = address.indexOf("//") + 2;
		ind = ind + address.substring(ind).indexOf("/");

		gVars.curr_dir = address.substring(ind);
		gVars.base_url = address.substring(0, ind);
		gVars.start_dir = gVars.curr_dir;

		window.title = gVars.base_url;

		lockMan = new LockManager();
		lockMan.loadLocks();

		populateList();

	}
	catch(e) {
		alert("OnLoad: " + e);
	}
}

